/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Contents of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.147 - (show annotations) (download)
Fri May 5 19:00:28 2006 UTC (17 years, 10 months ago) by ce107
Branch: MAIN
Changes since 1.146: +39 -3 lines
Updates to support PCL performance counters, fix real*4 bug for PAPIS
and enhance PAPI counter support (including IPC per timestep output)

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/tools/genmake2,v 1.146 2006/04/07 02:53:55 edhill Exp $
4 #
5 # Makefile generator for MITgcm UV codes
6 # created by cnh 03/98
7 # adapted by aja 06/98
8 # modified by aja 01/00
9 # rewritten in bash by eh3 08/03
10
11 # Search for particular CPP #cmds associated with packages
12 # usage: test_for_package_in_cpp_options CPP_file package_name
13 test_for_package_in_cpp_options() {
14 cpp_options=$1
15 pkg=$2
16 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24 }
25
26 # Search for particular CPP #cmds associated with MPI
27 # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28 test_for_mpi_in_cpp_eeoptions() {
29 cpp_options=$1
30 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38 }
39
40 # Search for particular string in a file. Return 1 if detected, 0 if not
41 # usage: test_for_string_in_file file string
42 test_for_string_in_file() {
43 file=$1
44 strng=$2
45 grep -i "$strng" $file > /dev/null 2>&1
46 RETVAL=$?
47 if test "x${RETVAL}" = x0 ; then
48 printf "Error: In $file there is an illegal line: "
49 grep -i "$strng" $file
50 exit 99
51 fi
52 return 0
53 }
54
55 # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
56 # the package list.
57 expand_pkg_groups() {
58 new_packages=
59 PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
60 if test -r $PKG_GROUPS ; then
61 cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
62 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
63 matched=0
64 for i in $PACKAGES ; do
65 line=`grep "^ *$i" ./p2.tmp`
66 RETVAL=$?
67 if test "x$RETVAL" = x0 ; then
68 matched=1
69 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
70 echo " replacing \"$i\" with: $replace"
71 new_packages="$new_packages $replace"
72 else
73 new_packages="$new_packages $i"
74 fi
75 done
76 PACKAGES=$new_packages
77 rm -f ./p[1,2].tmp
78 return $matched
79 else
80 echo "Warning: can't read package groups definition file: $PKG_GROUPS"
81 fi
82 }
83
84 # Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
85 # cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
86 check_for_broken_Ff() {
87 # Do we have defaults for $FS and/or $FS90 ?
88 tfs=f
89 tfs9=f90
90 if test "x$FS" != x ; then
91 tfs="$FS"
92 fi
93 if test "x$FS90" != x ; then
94 tfs9="$FS90"
95 fi
96
97 # First check the ability to create a *.F/.f pair.
98 cat <<EOF >> genmake_hello.F
99 program hello
100 write(*,*) 'hi'
101 stop
102 end
103 EOF
104 cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
105 RETVAL=$?
106 if test "x$RETVAL" != x0 ; then
107 if test "x$FS" = x ; then
108 FS='for'
109 FS90='fr9'
110 check_for_broken_Ff
111 else
112 cat <<EOF 2>&1
113 ERROR: Your file system cannot distinguish between *.F and *.f files
114 (fails the "cp" test) and this program cannot find a suitable
115 replacement extension. Please try a different build environment or
116 contact the <MITgcm-support@mitgcm.org> list for help.
117
118 EOF
119 exit -1
120 fi
121 return
122 fi
123 rm -f genmake_hello.*
124
125 # Check the ability of ${MAKE} and ${LN} to use the current set
126 # of extensions.
127 cat <<EOF >> genmake_hello.F
128 program hello
129 write(*,*) 'hi'
130 stop
131 end
132 EOF
133 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
134 cat <<EOF >> $MAKEFILE
135 .SUFFIXES:
136 .SUFFIXES: .$tfs .F
137 .F.$tfs:
138 $LN \$< \$@
139 EOF
140 $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141 RETVAL=$?
142 if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143 if test "x$FS" = x ; then
144 FS='for'
145 FS90='fr9'
146 check_for_broken_Ff
147 else
148 cat <<EOF 2>&1
149 ERROR: Your file system cannot distinguish between *.F and *.f files
150 (fails the "make/ln" test) and this program cannot find a suitable
151 replacement extension. Please try a different build environment or
152 contact the <MITgcm-support@mitgcm.org> list for help.
153
154 EOF
155 exit -1
156 return
157 fi
158 fi
159 rm -f genmake_hello.* $MAKEFILE
160 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
161
162 # If we make it here, use the extensions
163 FS=$tfs
164 FS90=$tfs9
165 return
166 }
167
168
169 look_for_makedepend() {
170
171 # The "original" makedepend is part of the Imake system that is
172 # most often distributed with XFree86 or with an XFree86 source
173 # package. As a result, many machines (eg. generic Linux) do not
174 # have a system-default "makedepend" available. For those
175 # systems, we have two fall-back options:
176 #
177 # 1) a makedepend implementation shipped with the cyrus-imapd
178 # package: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179 #
180 # 2) a known-buggy xmakedpend shell script
181 #
182 # So the choices are, in order:
183 #
184 # 1) use the user-specified program
185 # 2) use a system-wide default
186 # 3) locally build and use the cyrus implementation
187 # 4) fall back to the buggy local xmakedpend script
188 #
189 if test "x${MAKEDEPEND}" = x ; then
190 which makedepend > /dev/null 2>&1
191 RV0=$?
192 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
193 # echo 'MAKEFILE="'$MAKEFILE'"'
194 cat <<EOF >> $MAKEFILE
195 # THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196 #
197 # Some "makedepend" implementations will die if they cannot
198 # find a Makefile -- so this file is here to gives them an
199 # empty one to find and parse.
200 EOF
201 cat <<EOF >> genmake_tc.f
202 program test
203 write(*,*) 'test'
204 stop
205 end
206 EOF
207 makedepend genmake_tc.f > /dev/null 2>&1
208 RV1=$?
209 test -f $MAKEFILE && rm -f $MAKEFILE
210 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
211 if test "x${RV0}${RV1}" = x00 ; then
212 MAKEDEPEND=makedepend
213 else
214 echo " a system-default makedepend was not found."
215
216 # Try to build the cyrus implementation
217 build_cyrus_makedepend
218 RETVAL=$?
219 if test "x$RETVAL" != x0 ; then
220 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221 fi
222 rm -f ./genmake_cy_md
223 fi
224 else
225 # echo "MAKEDEPEND=${MAKEDEPEND}"
226 echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227 RETVAL=$?
228 if test x"$RETVAL" = x0 ; then
229 build_cyrus_makedepend
230 fi
231 fi
232 }
233
234
235 build_cyrus_makedepend() {
236 rm -f ./genmake_cy_md
237 (
238 cd $ROOTDIR/tools/cyrus-imapd-makedepend \
239 && ./configure > /dev/null 2>&1 \
240 && make > /dev/null 2>&1
241 if test -x ./makedepend.exe ; then
242 $LN ./makedepend.exe ./makedepend
243 fi
244 ./makedepend ifparser.c > /dev/null 2>&1 \
245 && echo "true"
246 ) > ./genmake_cy_md
247 grep true ./genmake_cy_md > /dev/null 2>&1
248 RETVAL=$?
249 rm -f ./genmake_cy_md
250 if test "x$RETVAL" = x0 ; then
251 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252 return 0
253 else
254 echo "WARNING: unable to build cyrus-imapd-makedepend"
255 return 1
256 fi
257 }
258
259
260 build_embed_encode()
261 {
262 printf " building the embed-encode utility... "
263 if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264 if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265 echo
266 echo " Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267 echo
268 EMBED_SRC=f
269 return 1
270 fi
271 clist="cc gcc c89 $CC"
272 for ic in $clist ; do
273 comm="$ic -o encode_files encode_files.c"
274 ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275 RETVAL=$?
276 if test "x$RETVAL" = x0 ; then
277 echo "OK"
278 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279 return 0
280 fi
281 done
282 echo
283 echo " Error: unable to build $ROOTDIR/embed_encode/encode_files"
284 echo " so it has been disabled"
285 echo
286 EMBED_SRC=f
287 return 1
288 fi
289 echo "OK"
290 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291 }
292
293
294 # Guess possible config options for this host
295 find_possible_configs() {
296
297 tmp1=`uname`"_"`uname -m`
298 tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
299 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
300 tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
301 tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
302 tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
303 PLATFORM=$tmp3
304 echo $PLATFORM | grep cygwin > /dev/null 2>&1 && PLATFORM=cygwin_ia32
305 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
306 echo " The platform appears to be: $PLATFORM"
307
308 echo "test" > test
309 ln -s ./test link
310 RETVAL=$?
311 if test "x${RETVAL}" = x0 ; then
312 LN="ln -s"
313 else
314 echo "Error: \"ln -s\" does not appear to work on this system!"
315 echo " For help, please contact <MITgcm-support@mitgcm.org>."
316 exit 1
317 fi
318 rm -f test link
319
320 if test "x$CPP" = x ; then
321 CPP="cpp -traditional -P"
322 fi
323
324 look_for_makedepend
325
326 #================================================================
327 # look for possible C compilers
328 tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
329 p_CC=
330 for c in $tmp ; do
331 rm -f ./genmake_hello.c ./genmake_hello
332 cat >> genmake_hello.c << EOF
333 #include <stdio.h>
334 int main(int argc, char **argv) {
335 printf("Hello!\n");
336 return 0;
337 }
338 EOF
339 $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340 RETVAL=$?
341 if test "x${RETVAL}" = x0 ; then
342 p_CC="$p_CC $c"
343 fi
344 done
345 rm -f ./genmake_hello.c ./genmake_hello
346 if test "x${p_CC}" = x ; then
347 cat 1>&2 <<EOF
348
349 Error: No C compilers were found in your path. Please specify one using:
350
351 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352 2) the CC or MITGCM_CC environment variables.
353
354 EOF
355 exit 1
356 else
357 echo " The possible C compilers found in your path are:"
358 echo " "$p_CC
359 if test "x$CC" = x ; then
360 CC=`echo $p_CC | $AWK '{print $1}'`
361 echo " Setting C compiler to: "$CC
362 fi
363 fi
364
365 #================================================================
366 # look for possible FORTRAN compilers
367 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"
368 p_FC=
369 for c in $tmp ; do
370 rm -f ./hello.f ./hello
371 cat >> hello.f <<EOF
372 program hello
373 do i=1,3
374 print *, 'hello world : ', i
375 enddo
376 end
377 EOF
378 $c -o hello hello.f > /dev/null 2>&1
379 RETVAL=$?
380 if test "x${RETVAL}" = x0 ; then
381 p_FC="$p_FC $c"
382 fi
383 done
384 rm -f ./hello.f ./hello
385 if test "x${p_FC}" = x ; then
386 cat 1>&2 <<EOF
387
388 Error: No Fortran compilers were found in your path. Please specify one using:
389
390 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391 2) a command-line option (eg. "-fc NAME"), or
392 3) the FC or MITGCM_FC environment variables.
393
394 EOF
395 exit 1
396 else
397 echo " The possible FORTRAN compilers found in your path are:"
398 echo " "$p_FC
399 fi
400
401 # Use the first of the compilers found in the current PATH
402 # that has a correctly-named optfile
403 if test "x$OPTFILE" = x -a "x$FC" = x ; then
404 for i in $p_FC ; do
405 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406 if test -r $OPTFILE ; then
407 echo " Setting OPTFILE to: "$OPTFILE
408 break
409 fi
410 done
411 fi
412
413 if test "x$OPTFILE" = x ; then
414 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
415 if test ! -r $OPTFILE ; then
416 echo " I looked for the file "$OPTFILE" but did not find it"
417 fi
418 fi
419 # echo " The options file: $p_OF"
420 # echo " appears to match so we'll use it."
421 # for i in $p_FC ; do
422 #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
423 #if test -r $p_OF ; then
424 # OPTFILE=$p_OF
425 # echo " The options file: $p_OF"
426 # echo " appears to match so we'll use it."
427 # break
428 #fi
429 # done
430 if test "x$OPTFILE" = x ; then
431 cat 1>&2 <<EOF
432
433 Error: No options file was found in: $ROOTDIR/tools/build_options/
434 that matches this platform ("$PLATFORM") and the compilers found in
435 your path. Please specify an "optfile" using:
436
437 1) the command line (eg. "-optfile=path/to/OPTFILE"), or
438 2) the MITGCM_OF environment variable.
439
440 If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
441
442 EOF
443 exit 1
444 fi
445
446 # # look for possible MPI libraries
447 # mpi_libs=
448 # mpi_fort=`which mpif77 2>/dev/null`
449 # RETVAL=$?
450 # if test "x${RETVAL}" = x0 ; then
451 # cat >>test.f <<EOF
452 # PROGRAM HELLO
453 # DO 10, I=1,10
454 # PRINT *,'Hello World'
455 # 10 CONTINUE
456 # STOP
457 # END
458 # EOF
459 # eval "$mpi_fort -showme test.f > out"
460 # RETVAL=$?
461 # if test "x${RETVAL}" = x0 ; then
462 # a=`cat out`
463 # for i in $a ; do
464 # case $i in
465 # -*)
466 # mpi_libs="$mpi_libs $i" ;;
467 # esac
468 # done
469 # echo "The MPI libs appear to be:"
470 # echo " "$mpi_libs
471 # fi
472 # rm -f test.f out
473 # fi
474
475 }
476
477 # Parse the package dependency information
478 get_pdepend_list() {
479
480 # strip the comments and then convert the dependency file into
481 # two arrays: PNAME, DNAME
482 cat $1 | sed -e 's/#.*$//g' \
483 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
484 > ./.pd_tmp
485 . ./.pd_tmp
486 rm -f ./.pd_tmp
487
488 printf "PNAME = "${}
489 }
490
491
492 # Explain usage
493 usage() {
494 cat <<EOF
495
496 Usage: "$0" [OPTIONS]
497 where [OPTIONS] can be:
498
499 -help | --help | -h | --h
500 Print this help message and exit.
501
502 -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
503 -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
504 Use "NAME" as the adoptfile. By default, the file at
505 "tools/adjoint_options/adjoint_default" will be used.
506
507 -nooptfile | --nooptfile
508 -optfile NAME | --optfile NAME | -of NAME | --of NAME
509 -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
510 Use "NAME" as the optfile. By default, an attempt will be
511 made to find an appropriate "standard" optfile in the
512 tools/build_options/ directory.
513
514 -pdepend NAME | --pdepend NAME
515 -pdepend=NAME | --pdepend=NAME
516 Get package dependency information from "NAME".
517
518 -pdefault NAME | --pdefault NAME
519 -pdefault=NAME | --pdefault=NAME
520 Get the default package list from "NAME".
521
522 -make NAME | -m NAME
523 --make=NAME | -m=NAME
524 Use "NAME" for the MAKE program. The default is "make" but
525 many platforms, "gmake" is the preferred choice.
526
527 -makefile NAME | -mf NAME
528 --makefile=NAME | -mf=NAME
529 Call the makefile "NAME". The default is "Makefile".
530
531 -makedepend NAME | -md NAME
532 --makedepend=NAME | -md=NAME
533 Use "NAME" for the MAKEDEPEND program.
534
535 -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
536 -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
537 Specify the location of the MITgcm ROOTDIR as "NAME".
538 By default, genamke will try to find the location by
539 looking in parent directories (up to the 5th parent).
540
541 -mods NAME | --mods NAME | -mo NAME | --mo NAME
542 -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
543 Here, "NAME" specifies a list of directories that are
544 used for additional source code. Files found in the
545 "mods list" are given preference over files of the same
546 name found elsewhere.
547
548 -disable NAME | --disable NAME
549 -disable=NAME | --disable=NAME
550 Here "NAME" specifies a list of packages that we don't
551 want to use. If this violates package dependencies,
552 genamke will exit with an error message.
553
554 -enable NAME | --enable NAME
555 -enable=NAME | --enable=NAME
556 Here "NAME" specifies a list of packages that we wish
557 to specifically enable. If this violates package
558 dependencies, genamke will exit with an error message.
559
560 -standarddirs NAME | --standarddirs NAME
561 -standarddirs=NAME | --standarddirs=NAME
562 Here, "NAME" specifies a list of directories to be
563 used as the "standard" code.
564
565 -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
566 -fc=NAME | --fc=NAME
567 Use "NAME" as the fortran compiler. By default, genmake
568 will search for a working compiler by trying a list of
569 "usual suspects" such as g77, f77, etc.
570
571 -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572 Use "NAME" as the C compiler. By default, genmake
573 will search for a working compiler by trying a list of
574 "usual suspects" such as gcc, c89, cc, etc.
575
576 -[no]ieee | --[no]ieee
577 Do or don't use IEEE numerics. Note that this option
578 *only* works if it is supported by the OPTFILE that
579 is being used.
580
581 -ignoretime | -ignore_time | --ignoretime | --ignore_time
582 Ignore all the "wall clock" routines entirely. This will
583 not in any way hurt the model results -- it simply means
584 that the code that checks how long the model spends in
585 various routines will give junk values.
586
587 -ts | --ts
588 Produce timing information per timestep
589 -papis | --papis
590 Produce summary MFlop/s (and IPC) with PAPI per timestep
591 -pcls | --pcls
592 Produce summary MFlop/s etc. with PCL per timestep
593 -foolad | --foolad
594 Fool the AD code generator
595 -papi | --papi
596 Performance analysis with PAPI
597 -pcl | --pcl
598 Performance analysis with PCL
599 -hpmt | --hpmt
600 Performance analysis with the HPM Toolkit
601
602 -gsl | --gsl
603 Use GSL to control floating point rounding and precision
604
605 -mpi | --mpi
606 Include MPI header files and link to MPI libraries
607 -mpi=PATH | --mpi=PATH
608 Include MPI header files and link to MPI libraries using MPI_ROOT
609 set to PATH. i.e. Include files from \$PATH/include, link to libraries
610 from \$PATH/lib and use binaries from \$PATH/bin.
611
612 -es | --es | -embed-source | --embed-source
613 Embed a tarball containing the full source code
614 (including the Makefile, etc.) used to build the
615 executable [off by default]
616
617 -bash NAME
618 Explicitly specify the Bourne or BASH shell to use
619
620 While it is most often a single word, the "NAME" variables specified
621 above can in many cases be a space-delimited string such as:
622
623 --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'
624 -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'
625 -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
626
627 which, depending upon your shell, may need to be single-quoted.
628
629 For more detailed genmake documentation, please see:
630
631 http://mitgcm.org/devel_HOWTO/
632
633 EOF
634
635 exit 1
636 }
637
638 # Build a CPP macro to automate calling C routines from FORTRAN
639 get_fortran_c_namemangling() {
640
641 #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
642 if test ! "x$FC_NAMEMANGLE" = x ; then
643 return 0
644 fi
645
646 default_nm="#define FC_NAMEMANGLE(X) X ## _"
647
648 cat > genmake_test.c <<EOF
649 void tcall( char * string ) { tsub( string ); }
650 EOF
651 $MAKE genmake_test.o >> genmake_warnings 2>&1
652 RETVAL=$?
653 if test "x$RETVAL" != x0 ; then
654 FC_NAMEMANGLE=$default_nm
655 cat <<EOF>> genmake_errors
656
657 WARNING: C test compile fails
658 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
659 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
660 EOF
661 return 1
662 fi
663 c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
664 RETVAL=$?
665 if test "x$RETVAL" != x0 ; then
666 FC_NAMEMANGLE=$default_nm
667 cat <<EOF>> genmake_warnings
668
669 WARNING: The "nm" command failed.
670 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
671 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
672 EOF
673 return 1
674 fi
675 cat > genmake_tcomp.$FS <<EOF
676 subroutine tcall( string )
677 character*(*) string
678 call tsub( string )
679 end
680 EOF
681 $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
682 RETVAL=$?
683 if test "x$RETVAL" != x0 ; then
684 FC_NAMEMANGLE=$default_nm
685 cat <<EOF>> genmake_warnings
686
687 WARNING: FORTRAN test compile fails -- please see "genmake_errors"
688 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
689 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
690 EOF
691 return 1
692 fi
693 f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
694 RETVAL=$?
695 if test "x$RETVAL" != x0 ; then
696 FC_NAMEMANGLE=$default_nm
697 cat <<EOF>> genmake_warnings
698
699 WARNING: The "nm" command failed.
700 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
701 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
702 EOF
703 return 1
704 fi
705
706 c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
707 f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
708 c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
709 f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
710
711 nmangle="X"
712 if test "x$c_a" != "x$f_a" ; then
713 comm="echo x$f_a | sed -e 's|x$c_a||'"
714 a=`eval $comm`
715 nmangle="$a ## $nmangle"
716 fi
717 if test "x$c_b" != "x$f_b" ; then
718 comm="echo x$f_b | sed -e 's|x$c_b||'"
719 b=`eval $comm`
720 nmangle="$nmangle ## $b"
721 fi
722
723 FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmangle"
724
725 # cleanup the testing files
726 rm -f genmake_tcomp.* genmake_test.*
727 }
728
729
730 check_HAVE_CLOC() {
731 get_fortran_c_namemangling
732 cat <<EOF > genmake_tc_1.c
733 $FC_NAMEMANGLE
734 #include <stdio.h>
735 #include <stdlib.h>
736 #include <unistd.h>
737 #include <assert.h>
738 #include <sys/time.h>
739 void FC_NAMEMANGLE(cloc) ( double *curtim )
740 {
741 struct timeval tv1;
742 gettimeofday(&tv1 , (void *)NULL );
743 *curtim = (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
744 *curtim = *curtim/1.E6;
745 }
746 EOF
747 make genmake_tc_1.o >> genmake_warnings 2>&1
748 RET_C=$?
749 cat <<EOF > genmake_tc_2.$FS
750 program hello
751 REAL*8 wtime
752 external cloc
753 call cloc(wtime)
754 print *," HELLO WORLD", wtime
755 end
756 EOF
757 $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1
758 RET_F=$?
759 test -x ./genmake_tc && ./genmake_tc >> genmake_warnings 2>&1
760 RETVAL=$?
761 if test "x$RETVAL" = x0 ; then
762 HAVE_CLOC=t
763 DEFINES="$DEFINES -DHAVE_CLOC"
764 fi
765 rm -f genmake_tc*
766 }
767
768
769 check_HAVE_SIGREG() {
770 get_fortran_c_namemangling
771 cat <<EOF > genmake_tc_1.c
772 $FC_NAMEMANGLE
773 #include <stdlib.h>
774 #include <stdio.h>
775 #include <signal.h>
776 #include <errno.h>
777 #include <ucontext.h>
778
779 int * ip;
780
781 static void killhandler(
782 unsigned int sn, siginfo_t si, struct ucontext *sc )
783 {
784 *ip = *ip + 1;
785 return;
786 }
787
788 void FC_NAMEMANGLE(sigreg) (int * aip)
789 {
790 struct sigaction s;
791 ip = aip;
792 s.sa_flags = SA_SIGINFO;
793 s.sa_sigaction = (void *)killhandler;
794 if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
795 printf("Sigaction returned error = %d\n", errno);
796 exit(0);
797 }
798 return;
799 }
800 EOF
801 make genmake_tc_1.o >> genmake_warnings 2>&1
802 RET_C=$?
803 cat <<EOF > genmake_tc_2.$FS
804 program hello
805 integer anint
806 common /iv/ anint
807 external sigreg
808 call sigreg(anint)
809 end
810 EOF
811 echo >> genmake_warnings
812 echo "running: check_HAVE_SIGREG()" >> genmake_warnings
813 cat genmake_tc_2.$FS >> genmake_warnings
814 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
815 echo $COMM >> genmake_warnings
816 $COMM >> genmake_warnings 2>&1
817 RETVAL=$?
818 if test "x$RETVAL" = x0 ; then
819 HAVE_SIGREG=t
820 DEFINES="$DEFINES -DHAVE_SIGREG"
821 fi
822 rm -f genmake_tc*
823 }
824
825
826 check_HAVE_SETRLSTK() {
827 get_fortran_c_namemangling
828 cat <<EOF > genmake_tc_1.c
829 $FC_NAMEMANGLE
830 #include <sys/time.h>
831 #include <sys/resource.h>
832 #include <unistd.h>
833 void FC_NAMEMANGLE(setrlstk) ()
834 {
835 struct rlimit rls;
836 rls.rlim_cur = RLIM_INFINITY;
837 rls.rlim_max = RLIM_INFINITY;
838 setrlimit(RLIMIT_STACK, &rls);
839 return;
840 }
841 EOF
842 make genmake_tc_1.o >> genmake_warnings 2>&1
843 RET_C=$?
844 cat <<EOF > genmake_tc_2.$FS
845 program hello
846 external setrlstk
847 call setrlstk()
848 end
849 EOF
850 echo >> genmake_warnings
851 echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
852 cat genmake_tc_2.$FS >> genmake_warnings
853 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
854 echo $COMM >> genmake_warnings
855 $COMM >> genmake_warnings 2>&1
856 RETVAL=$?
857 if test "x$RETVAL" = x0 ; then
858 HAVE_SETRLSTK=t
859 DEFINES="$DEFINES -DHAVE_SETRLSTK"
860 fi
861 rm -f genmake_tc*
862 }
863
864
865 check_HAVE_STAT() {
866 get_fortran_c_namemangling
867 cat <<EOF > genmake_tc_1.c
868 $FC_NAMEMANGLE
869 #include <stdio.h>
870 #include <stdlib.h>
871 #include <unistd.h>
872 #include <sys/stat.h>
873 #include <sys/types.h>
874 void FC_NAMEMANGLE(tfsize) ( int *nbyte )
875 {
876 char name[512];
877 struct stat astat;
878
879 name[0] = 'a'; name[1] = '\0';
880 if (! stat(name, &astat))
881 *nbyte = (int)(astat.st_size);
882 else
883 *nbyte = -1;
884 }
885 EOF
886 make genmake_tc_1.o >> genmake_tc.log 2>&1
887 RET_C=$?
888 cat <<EOF > genmake_tc_2.$FS
889 program hello
890 integer nbyte
891 call tfsize(nbyte)
892 print *," HELLO WORLD", nbyte
893 end
894 EOF
895 echo >> genmake_warnings
896 echo "running: check_HAVE_STAT()" >> genmake_warnings
897 cat genmake_tc_2.$FS >> genmake_warnings
898 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
899 echo $COMM >> genmake_warnings
900 $COMM >> genmake_tc.log 2>&1
901 RETVAL=$?
902 if test "x$RETVAL" = x0 ; then
903 HAVE_STAT=t
904 DEFINES="$DEFINES -DHAVE_STAT"
905 fi
906 rm -f genmake_tc*
907 }
908
909
910 check_netcdf_libs() {
911 if test ! "x$SKIP_NETCDF_CHECK" = x ; then
912 return
913 fi
914 echo >> genmake_warnings
915 echo "running: check_netcdf_libs()" >> genmake_warnings
916 cat <<EOF > genmake_tnc.F
917 program fgennc
918 #include "netcdf.inc"
919 EOF
920 if test ! "x$MPI" = x ; then
921 echo '#include "mpif.h"' >> genmake_tnc.F
922 fi
923 cat <<EOF >> genmake_tnc.F
924 integer iret, ncid, xid
925 iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
926 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
927 iret = nf_def_dim(ncid, 'X', 11, xid)
928 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
929 iret = nf_close(ncid)
930 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
931 end
932 EOF
933 echo "=== genmake_tnc.F ===" > genmake_tnc.log
934 cat genmake_tnc.F >> genmake_tnc.log
935 echo "=== genmake_tnc.F ===" >> genmake_tnc.log
936 RET_CPP=f
937 COMM="$CPP $DEFINES $INCLUDES genmake_tnc.F"
938 echo "$COMM" >> genmake_tnc.log
939 $COMM > genmake_tnc.$FS 2>/dev/null && RET_CPP=t
940 if test "x$RET_CPP" = xf ; then
941 echo " WARNING: CPP failed to pre-process the netcdf test." \
942 >> genmake_tnc.log
943 echo " Please check that \$INCLUDES is properly set." \
944 >> genmake_tnc.log
945 fi
946 echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
947 echo " && $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log
948 $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
949 && $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
950 RET_COMPILE=$?
951 cat genmake_tnc.log >> genmake_warnings
952
953 #EH3 Remove test program execution for machines that either disallow
954 #EH3 execution or cannot support it (eg. cross-compilers)
955 #EH3
956 #EH3 test -x ./genmake_tnc && ./genmake_tnc >> genmake_tnc.log 2>&1
957 #EH3 RETVAL=$?
958 #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
959
960 if test "x$RET_COMPILE" = x0 ; then
961 HAVE_NETCDF=t
962 else
963 # try again with "-lnetcdf" added to the libs
964 echo "try again with added '-lnetcdf'" > genmake_tnc.log
965 echo "$CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS \ " >> genmake_tnc.log
966 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
967 echo " && $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
968 $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null \
969 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
970 && $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
971 RET_COMPILE=$?
972 cat genmake_tnc.log >> genmake_warnings
973 if test "x$RET_COMPILE" = x0 ; then
974 LIBS="$LIBS -lnetcdf"
975 HAVE_NETCDF=t
976 fi
977 fi
978 rm -f genmake_tnc*
979 }
980
981
982
983 ###############################################################################
984 # Sequential part of script starts here
985 ###############################################################################
986
987 # Set defaults here
988 COMMANDL="$0 $@"
989
990 PLATFORM=
991 LN=
992 S64=
993 KPP=
994 #FC=
995 #CC=gcc
996 #CPP=
997 LINK=
998 DEFINES=
999 PACKAGES=
1000 ENABLE=
1001 DISABLE=
1002 # MAKEFILE=
1003 # MAKEDEPEND=
1004 PDEPEND=
1005 DUMPSTATE=t
1006 PDEFAULT=
1007 OPTFILE=
1008 INCLUDES="-I. $INCLUDES"
1009 FFLAGS=
1010 FOPTIM=
1011 CFLAGS=
1012 KFLAGS1=
1013 KFLAGS2=
1014 #LDADD=
1015 LIBS=
1016 KPPFILES=
1017 NOOPTFILES=
1018 NOOPTFLAGS=
1019 MPI=
1020 MPIPATH=
1021 TS=
1022 PAPIS=
1023 PCLS=
1024 FOOLAD=
1025 PAPI=
1026 PCL=
1027 HPMT=
1028 GSL=
1029 HAVE_TEST_L=
1030
1031 # DEFINES checked by test compilation or command-line
1032 HAVE_SYSTEM=
1033 HAVE_FDATE=
1034 FC_NAMEMANGLE=
1035 HAVE_CLOC=
1036 HAVE_SETRLSTK=
1037 HAVE_STAT=
1038 HAVE_NETCDF=
1039 HAVE_ETIME=
1040 IGNORE_TIME=
1041
1042 MODS=
1043 TOOLSDIR=
1044 SOURCEDIRS=
1045 INCLUDEDIRS=
1046 STANDARDDIRS="USE_THE_DEFAULT"
1047
1048 G2ARGS=
1049 BASH=
1050 PWD=`pwd`
1051 test "x$MAKE" = x && MAKE=make
1052 test "x$AWK" = x && AWK=awk
1053 EMBED_SRC=
1054 THISHOST=`hostname`
1055 THISCWD=`pwd`
1056 THISDATE=`date`
1057 THISUSER=`echo $USER`
1058 THISVER=
1059 MACHINE=`uname -a`
1060 EXECUTABLE=
1061 EXEHOOK=
1062 EXEDIR=
1063 PACKAGES_CONF=
1064 IEEE=
1065 if test "x$MITGCM_IEEE" != x ; then
1066 IEEE=$MITGCM_IEEE
1067 fi
1068 FS=
1069 FS90=
1070
1071 AUTODIFF_PKG_USED=f
1072 AD_OPTFILE=
1073 TAF=
1074 AD_TAF_FLAGS=
1075 FTL_TAF_FLAGS=
1076 SVD_TAF_FLAGS=
1077 TAF_EXTRA=
1078 TAMC=
1079 AD_TAMC_FLAGS=
1080 FTL_TAF_FLAGS=
1081 SVD_TAMC_FLAGS=
1082 TAMC_EXTRA=
1083
1084
1085 # The following state can be set directly by command-line switches
1086 gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1087 gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"
1088
1089 # The following state is not directly set by command-line switches
1090 gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
1091 gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1092 gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1093 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1094 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1095
1096 # The following are all related to adjoint/tangent-linear stuff
1097 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
1098 gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1099 gm_s12="TAF_EXTRA TAMC_EXTRA"
1100
1101 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
1102 gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
1103
1104 cat <<EOF
1105
1106 GENMAKE :
1107
1108 A program for GENerating MAKEfiles for the MITgcm project. For a
1109 quick list of options, use "genmake -h" or for more detail see:
1110
1111 http://mitgcm.org/devel_HOWTO/
1112
1113 EOF
1114
1115 echo "=== Processing options files and arguments ==="
1116 gm_local="genmake_local"
1117 for i in . $MODS ; do
1118 if test -r $i/$gm_local ; then
1119 . $i/$gm_local
1120 break
1121 fi
1122 done
1123 printf " getting local config information: "
1124 if test -f $gm_local ; then
1125 echo "using $gm_local"
1126 . $gm_local
1127 # echo "DISABLE=$DISABLE"
1128 # echo "ENABLE=$ENABLE"
1129 else
1130 echo "none found"
1131 fi
1132
1133 #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1134 #OPTIONS=
1135 #n=0
1136 #for i ; do
1137 # echo "$i $n"
1138 # setvar="OPTIONS[$n]='$i'"
1139 # # echo " $setvar"
1140 # eval "$setvar"
1141 # n=$(( $n + 1 ))
1142 #done
1143 #parse_options
1144 ac_prev=
1145 for ac_option in "$@" ; do
1146
1147 G2ARGS="$G2ARGS \"$ac_option\""
1148
1149 # If the previous option needs an argument, assign it.
1150 if test -n "$ac_prev"; then
1151 eval "$ac_prev=\$ac_option"
1152 ac_prev=
1153 continue
1154 fi
1155
1156 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
1157
1158 case $ac_option in
1159
1160 -help | --help | -h | --h)
1161 usage ;;
1162
1163 -nooptfile | --nooptfile)
1164 OPTFILE="NONE" ;;
1165 -optfile | --optfile | -of | --of)
1166 ac_prev=OPTFILE ;;
1167 -optfile=* | --optfile=* | -of=* | --of=*)
1168 OPTFILE=$ac_optarg ;;
1169
1170 -adoptfile | --adoptfile | -adof | --adof)
1171 ac_prev=AD_OPTFILE ;;
1172 -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
1173 AD_OPTFILE=$ac_optarg ;;
1174
1175 -pdepend | --pdepend)
1176 ac_prev=PDEPEND ;;
1177 -pdepend=* | --pdepend=*)
1178 PDEPEND=$ac_optarg ;;
1179
1180 -pdefault | --pdefault)
1181 ac_prev=PDEFAULT ;;
1182 -pdefault=* | --pdefault=*)
1183 PDEFAULT=$ac_optarg ;;
1184
1185 -make | --make | -m | --m)
1186 ac_prev=MAKE ;;
1187 -make=* | --make=* | -m=* | --m=*)
1188 MAKE=$ac_optarg ;;
1189
1190 -bash | --bash)
1191 ac_prev=BASH ;;
1192 -bash=* | --bash=*)
1193 BASH=$ac_optarg ;;
1194
1195 -makedepend | --makedepend | -md | --md)
1196 ac_prev=MAKEDEPEND ;;
1197 -makedepend=* | --makedepend=* | -md=* | --md=*)
1198 MAKEDEPEND=$ac_optarg ;;
1199
1200 -makefile | --makefile | -ma | --ma)
1201 ac_prev=MAKEFILE ;;
1202 -makefile=* | --makefile=* | -ma=* | --ma=*)
1203 MAKEFILE=$ac_optarg ;;
1204
1205 -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
1206 echo "ERROR: The platform option has been removed. Please specify"
1207 echo " the build options using the \"optfile\" mechanism."
1208 echo
1209 usage
1210 ;;
1211
1212 -rootdir | --rootdir | -rd | --rd)
1213 ac_prev=ROOTDIR ;;
1214 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
1215 ROOTDIR=$ac_optarg ;;
1216
1217 -mods | --mods | -mo | --mo)
1218 ac_prev=MODS ;;
1219 -mods=* | --mods=* | -mo=* | --mo=*)
1220 MODS=$ac_optarg ;;
1221
1222 -disable | --disable)
1223 ac_prev=DISABLE ;;
1224 -disable=* | --disable=*)
1225 DISABLE=$ac_optarg ;;
1226
1227 -enable | --enable)
1228 ac_prev=ENABLE ;;
1229 -enable=* | --enable=*)
1230 ENABLE=$ac_optarg ;;
1231
1232 -standarddirs | --standarddirs)
1233 ac_prev=STANDARDDIRS ;;
1234 -standarddirs=* | --standarddirs=*)
1235 STANDARDDIRS=$ac_optarg ;;
1236
1237 # -cpp | --cpp)
1238 # ac_prev=cpp ;;
1239 # -cpp=* | --cpp=*)
1240 # CPP=$ac_optarg ;;
1241
1242 -cc | --cc)
1243 ac_prev=CC ;;
1244 -cc=* | --cc=*)
1245 CC=$ac_optarg ;;
1246
1247 -fortran | --fortran | -fc | --fc)
1248 ac_prev=FC ;;
1249 -fc=* | --fc=*)
1250 FC=$ac_optarg ;;
1251
1252 -fs | --fs)
1253 ac_prev=FS ;;
1254 -fs=* | --fs=*)
1255 FS=$ac_optarg ;;
1256
1257 -fs90 | --fs90)
1258 ac_prev=FS90 ;;
1259 -fs90=* | --fs90=*)
1260 FS90=$ac_optarg ;;
1261
1262 -ieee | --ieee)
1263 IEEE=true ;;
1264 -noieee | --noieee)
1265 IEEE= ;;
1266
1267 -ts | --ts)
1268 TS=true ;;
1269 -papis | --papis)
1270 PAPIS=true ;;
1271 -pcls | --pcls)
1272 PCLS=true ;;
1273 -foolad | --foolad)
1274 FOOLAD=true ;;
1275 -papi | --papi)
1276 PAPI=true ;;
1277 -pcl | --pcl)
1278 PCL=true ;;
1279 -hpmt | --hpmt)
1280 HPMT=true ;;
1281
1282 -gsl | --gsl)
1283 GSL=true ;;
1284
1285 -mpi | --mpi)
1286 MPI=true ;;
1287 -mpi=* | --mpi=*)
1288 MPIPATH=$ac_optarg
1289 MPI=true ;;
1290
1291 # -jam | --jam)
1292 # JAM=1 ;;
1293 # -nojam | --nojam)
1294 # JAM=0 ;;
1295
1296 -ds | --ds)
1297 DUMPSTATE=t ;;
1298
1299 -taf_extra | --taf_extra)
1300 ac_prev=TAF_EXTRA ;;
1301 -taf_extra=* | --taf_extra=*)
1302 TAF_EXTRA=$ac_optarg ;;
1303
1304 -tamc_extra | --tamc_extra)
1305 ac_prev=TAMC_EXTRA ;;
1306 -tamc_extra=* | --tamc_extra=*)
1307 TAMC_EXTRA=$ac_optarg ;;
1308
1309 -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1310 IGNORE_TIME="-DIGNORE_TIME" ;;
1311
1312 -es | --es | -embed-source | --embed-source)
1313 EMBED_SRC=t ;;
1314
1315 -*)
1316 echo "Error: unrecognized option: "$ac_option
1317 usage
1318 ;;
1319
1320 *)
1321 echo "Error: unrecognized argument: "$ac_option
1322 usage
1323 ;;
1324
1325 esac
1326
1327 done
1328
1329
1330 if test -f ./.genmakerc ; then
1331 echo
1332 echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1333 echo " file. This file format is no longer supported. Please see:"
1334 echo
1335 echo " http://mitgcm.org/devel_HOWTO/"
1336 echo
1337 echo " for directions on how to setup and use the new \"genmake2\" input"
1338 echo " files and send an email to MITgcm-support@mitgcm.org if you want help."
1339 echo
1340 fi
1341
1342 # Find the MITgcm ${ROOTDIR}
1343 if test "x${ROOTDIR}" = x ; then
1344 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1345 if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1346 ROOTDIR=".."
1347 else
1348 for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1349 if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1350 ROOTDIR=$d
1351 printf "Warning: ROOTDIR was not specified but there appears to be"
1352 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1353 break
1354 fi
1355 done
1356 fi
1357 fi
1358 if test "x${ROOTDIR}" = x ; then
1359 echo "Error: Cannot determine ROOTDIR for MITgcm code."
1360 echo " Please specify a ROOTDIR using either an options "
1361 echo " file or a command-line option."
1362 exit 1
1363 fi
1364 if test ! -d ${ROOTDIR} ; then
1365 echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
1366 exit 1
1367 fi
1368
1369 # Find the MITgcm ${THISVER}
1370 if test -f "${ROOTDIR}/doc/tag-index" ; then
1371 THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1372 fi
1373
1374 if test "x$MAKEFILE" = x ; then
1375 MAKEFILE="Makefile"
1376 fi
1377
1378 echo " getting OPTFILE information: "
1379 if test "x${OPTFILE}" = x ; then
1380 if test "x$MITGCM_OF" = x ; then
1381 echo "Warning: no OPTFILE specified so we'll look for possible settings"
1382 printf "\n=== Searching for possible settings for OPTFILE ===\n"
1383 find_possible_configs
1384 else
1385 OPTFILE=$MITGCM_OF
1386 fi
1387 fi
1388 if test "x$OPTFILE" != xNONE ; then
1389 if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1390 echo " using OPTFILE=\"$OPTFILE\""
1391 . "$OPTFILE"
1392 RETVAL=$?
1393 if test "x$RETVAL" != x0 ; then
1394 printf "Error: failed to source OPTFILE \"$OPTFILE\""
1395 echo "--please check that variable syntax is bash-compatible"
1396 exit 1
1397 fi
1398 if test "x$DUMPSTATE" != xf ; then
1399 cp -f $OPTFILE "genmake_optfile"
1400 fi
1401 else
1402 echo "Error: can't read OPTFILE=\"$OPTFILE\""
1403 exit 1
1404 fi
1405 fi
1406
1407 echo " getting AD_OPTFILE information: "
1408 if test "x${AD_OPTFILE}" = x ; then
1409 if test "x$MITGCM_AD_OF" = x ; then
1410 AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1411 else
1412 AD_OPTFILE=$MITGCM_AD_OF
1413 fi
1414 fi
1415 if test "x${AD_OPTFILE}" != xNONE ; then
1416 if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1417 echo " using AD_OPTFILE=\"$AD_OPTFILE\""
1418 . "$AD_OPTFILE"
1419 RETVAL=$?
1420 if test "x$RETVAL" != x0 ; then
1421 printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1422 echo "--please check that variable syntax is bash-compatible"
1423 exit 1
1424 fi
1425 if test "x$DUMPSTATE" != xf ; then
1426 cp -f $AD_OPTFILE "genmake_ad_optfile"
1427 fi
1428 else
1429 echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1430 exit 1
1431 fi
1432 fi
1433
1434 #====================================================================
1435 # Set default values if not set by the optfile
1436 #
1437 # Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined. If not,
1438 # either set defaults or complain and abort!
1439 if test ! "x$BASH" = x ; then
1440 # add a trailing space so that it works within the Makefile syntax (see below)
1441 BASH="$BASH "
1442 fi
1443 if test "x$FC" = x ; then
1444 cat <<EOF 1>&2
1445
1446 Error: no Fortran compiler: please specify using one of the following:
1447 1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1448 2) the "-fc=XXX" command-line option
1449 3) the "./genmake_local" file
1450 EOF
1451 exit 1
1452 fi
1453 if test "x$CC" = x ; then
1454 CC=cc
1455 # cat <<EOF 1>&2
1456 # Error: no C compiler: please specify using one of the following:
1457 # 1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1458 # 2) the "-cc=XXX" command-line option
1459 # 3) the "./genmake_local" file
1460 # EOF
1461 # exit 1
1462 fi
1463 if test "x$LINK" = x ; then
1464 LINK=$FC
1465 fi
1466 if test "x$MAKE" = x ; then
1467 MAKE="make"
1468 fi
1469 if test "x$CPP" = x ; then
1470 CPP=cpp
1471 fi
1472 #EH3 === UGLY ===
1473 # The following is an ugly little hack to check for $CPP in /lib/ and
1474 # it should eventually be replaced with a more general function that
1475 # searches a combo of the user's path and a list of "usual suspects"
1476 # to find the correct location for binaries such as $CPP.
1477 for i in " " "/lib/" ; do
1478 echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1479 done
1480 #EH3 === UGLY ===
1481 echo "#define A a" | $CPP > test_cpp 2>&1
1482 RETVAL=$?
1483 if test "x$RETVAL" != x0 ; then
1484 cat <<EOF 1>&2
1485
1486 Error: C pre-processor "$CPP" failed the test case: please specify using:
1487
1488 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1489 2) the "./genmake_local" file
1490 3) with the CPP environment variable
1491
1492 EOF
1493 exit 1
1494 else
1495 rm -f test_cpp
1496 fi
1497 look_for_makedepend
1498 if test "x$LN" = x ; then
1499 LN="ln -s"
1500 fi
1501 echo "test" > genmake_test_ln
1502 $LN genmake_test_ln genmake_tlink
1503 RETVAL=$?
1504 if test "x$RETVAL" != x0 ; then
1505 cat <<EOF 1>&2
1506
1507 Error: The command "ln -s" failed -- please specify a working soft-link
1508 command in the optfile.
1509
1510 EOF
1511 exit 1
1512 fi
1513 test -L genmake_tlink > /dev/null 2>&1
1514 RETVAL=$?
1515 if test "x$RETVAL" = x0 ; then
1516 HAVE_TEST_L=t
1517 fi
1518 rm -f genmake_test_ln genmake_tlink
1519
1520 # Check for broken *.F/*.f handling and fix if possible
1521 check_for_broken_Ff
1522
1523 if test ! "x$MPI" = x ; then
1524 echo " Turning on MPI cpp macros"
1525 DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1526 fi
1527
1528 if test ! "x$TS" = x ; then
1529 echo " Turning on timing per timestep"
1530 if test ! "x$FOOLAD" = x ; then
1531 DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1532 else
1533 DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1534 fi
1535 fi
1536 if test ! "x$PAPIS" = x ; then
1537 echo " Turning on PAPI flop summary per timestep"
1538 echo " Please make sure PAPIINC, PAPILIB are defined"
1539 if test ! "x$FOOLAD" = x ; then
1540 DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1541 else
1542 DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1543 fi
1544 INCLUDES="$INCLUDES $PAPIINC"
1545 LIBS="$LIBS $PAPILIB"
1546 fi
1547 if test ! "x$PCLS" = x ; then
1548 echo " Turning on PCL counter summary per timestep"
1549 echo " Please make sure PCLINC, PCLLIB are defined"
1550 if test ! "x$FOOLAD" = x ; then
1551 DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1552 else
1553 DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1554 fi
1555 INCLUDES="$INCLUDES $PCLINC"
1556 LIBS="$LIBS $PCLLIB"
1557 fi
1558 if test ! "x$PAPI" = x ; then
1559 if test ! "x$PAPIS" = x ; then
1560 echo " PAPI performance analysis and flop summary per timestep cannot co-exist!"
1561 echo " Sticking with PAPI flop summary per timestep!"
1562 else
1563 echo " Turning on performance analysis with PAPI"
1564 echo " Please make sure PAPIINC, PAPILIB are defined"
1565 DEFINES="$DEFINES -DUSE_PAPI"
1566 INCLUDES="$INCLUDES $PAPIINC"
1567 LIBS="$LIBS $PAPILIB"
1568 fi
1569 fi
1570 if test ! "x$PCL" = x ; then
1571 if test ! "x$PCLS" = x ; then
1572 echo " PCL performance analysis and flop summary per timestep cannot co-exist!"
1573 echo " Sticking with PCL flop summary per timestep!"
1574 else
1575 echo " Turning on performance analysis with PCL"
1576 echo " Please make sure PCLINC, PCLLIB are defined"
1577 DEFINES="$DEFINES -DUSE_PCL"
1578 INCLUDES="$INCLUDES $PCLINC"
1579 LIBS="$LIBS $PCLLIB"
1580 fi
1581 fi
1582 if test ! "x$HPMT" = x ; then
1583 if test ! "x$PAPI" = x ; then
1584 echo " PAPI and the HPM Toolkit cannot co-exist!"
1585 echo " Sticking with PAPI!"
1586 else if test ! "x$PCL" = x ; then
1587 echo " PCL and the HPM Toolkit cannot co-exist!"
1588 echo " Sticking with PCL!"
1589 else
1590 echo " Turning on performance analysis with the HPM Toolkit"
1591 echo " Please make sure HPMTINC, HPMTLIB are defined"
1592 DEFINES="$DEFINES -DUSE_LIBHPM"
1593 INCLUDES="$INCLUDES $HPMTINC"
1594 LIBS="$LIBS $HPMTLIB"
1595 fi
1596 fi
1597 if test ! "x$GSL" = x ; then
1598 echo " Turning on use of GSL to control floating point calculations"
1599 echo " Please make sure GSLINC, GSLLIB are defined"
1600 DEFINES="$DEFINES -DUSE_GSL_IEEE"
1601 INCLUDES="$INCLUDES $GSLINC"
1602 LIBS="$LIBS $GSLLIB"
1603 fi
1604
1605 printf "\n=== Checking system libraries ===\n"
1606 printf " Do we have the system() command using $FC... "
1607 cat > genmake_tcomp.$FS <<EOF
1608 program hello
1609 call system('echo hi')
1610 end
1611 EOF
1612 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1613 RETVAL=$?
1614 if test "x$RETVAL" = x0 ; then
1615 HAVE_SYSTEM=t
1616 DEFINES="$DEFINES -DHAVE_SYSTEM"
1617 echo "yes"
1618 else
1619 HAVE_SYSTEM=
1620 echo "no"
1621 fi
1622 rm -f genmake_tcomp*
1623
1624 printf " Do we have the fdate() command using $FC... "
1625 cat > genmake_tcomp.$FS <<EOF
1626 program hello
1627 CHARACTER*(128) string
1628 string = ' '
1629 call fdate( string )
1630 print *, string
1631 end
1632 EOF
1633 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1634 RETVAL=$?
1635 if test "x$RETVAL" = x0 ; then
1636 HAVE_FDATE=t
1637 DEFINES="$DEFINES -DHAVE_FDATE"
1638 echo "yes"
1639 else
1640 HAVE_FDATE=
1641 echo "no"
1642 fi
1643 rm -f genmake_tcomp*
1644
1645 printf " Do we have the etime() command using $FC... "
1646 cat > genmake_tcomp.$FS <<EOF
1647 program hello
1648 REAL*4 ACTUAL, TARRAY(2)
1649 EXTERNAL ETIME
1650 REAL*4 ETIME
1651 actual = etime( tarray )
1652 print *, tarray
1653 end
1654 EOF
1655 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1656 RETVAL=$?
1657 if test "x$RETVAL" = x0 ; then
1658 HAVE_ETIME=t
1659 DEFINES="$DEFINES -DHAVE_ETIME"
1660 echo "yes"
1661 else
1662 HAVE_ETIME=
1663 echo "no"
1664 fi
1665 rm -f genmake_tcomp*
1666
1667 printf " Can we call simple C routines (here, \"cloc()\") using $FC... "
1668 check_HAVE_CLOC
1669 if test "x$HAVE_CLOC" != x ; then
1670 echo "yes"
1671 else
1672 echo "no"
1673 if test "x$EMBED_SRC" = xt ; then
1674 echo " WARNING: you requested file embedding but it has"
1675 echo " been disabled since C code cannot be called"
1676 EMBED_SRC=
1677 fi
1678 fi
1679 rm -f genmake_t*
1680
1681 printf " Can we unlimit the stack size using $FC... "
1682 check_HAVE_SETRLSTK
1683 if test "x$HAVE_SETRLSTK" != x ; then
1684 echo "yes"
1685 else
1686 echo "no"
1687 fi
1688 rm -f genmake_t*
1689
1690 printf " Can we register a signal handler using $FC... "
1691 check_HAVE_SIGREG
1692 if test "x$HAVE_SIGREG" != x ; then
1693 echo "yes"
1694 else
1695 echo "no"
1696 fi
1697 rm -f genmake_t*
1698
1699 printf " Can we use stat() through C calls... "
1700 check_HAVE_STAT
1701 if test "x$HAVE_STAT" != x ; then
1702 echo "yes"
1703 else
1704 echo "no"
1705 fi
1706 rm -f genmake_t*
1707
1708 printf " Can we create NetCDF-enabled binaries... "
1709 check_netcdf_libs
1710 if test "x$HAVE_NETCDF" != x ; then
1711 echo "yes"
1712 else
1713 echo "no"
1714 fi
1715 DEFINES="$DEFINES $IGNORE_TIME"
1716
1717 if test "x$EMBED_SRC" = xt ; then
1718 build_embed_encode
1719 fi
1720 if test "x$EMBED_SRC" = xt ; then
1721 ENABLE="$ENABLE embed_files"
1722 fi
1723
1724
1725 printf "\n=== Setting defaults ===\n"
1726 printf " Adding MODS directories: "
1727 for d in $MODS ; do
1728 if test ! -d $d ; then
1729 echo
1730 echo "Error: MODS directory \"$d\" not found!"
1731 exit 1
1732 else
1733 printf " $d"
1734 SOURCEDIRS="$SOURCEDIRS $d"
1735 INCLUDEDIRS="$INCLUDEDIRS $d"
1736 fi
1737 done
1738 echo
1739
1740 if test "x${PLATFORM}" = x ; then
1741 PLATFORM=$p_PLATFORM
1742 fi
1743
1744 if test "x${EXEDIR}" = x ; then
1745 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1746 if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1747 EXEDIR=../exe
1748 else
1749 EXEDIR=.
1750 fi
1751 fi
1752 if test ! -d ${EXEDIR} ; then
1753 echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
1754 exit 1
1755 fi
1756
1757 if test "x${TOOLSDIR}" = x ; then
1758 TOOLSDIR="$ROOTDIR/tools"
1759 fi
1760 if test ! -d ${TOOLSDIR} ; then
1761 echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1762 exit 1
1763 fi
1764 if test "x$S64" = x ; then
1765 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1766 RETVAL=$?
1767 if test "x${RETVAL}" = x0 ; then
1768 S64='$(TOOLSDIR)/set64bitConst.sh'
1769 else
1770 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1771 RETVAL=$?
1772 if test "x${RETVAL}" = x0 ; then
1773 S64='$(TOOLSDIR)/set64bitConst.csh'
1774 else
1775 cat <<EOF
1776
1777 ERROR: neither of the two default scripts:
1778
1779 ${TOOLSDIR}/set64bitConst.sh
1780 ${TOOLSDIR}/set64bitConst.csh
1781
1782 are working so please check paths or specify (with \$S64) a
1783 working version of this script.
1784
1785 EOF
1786 exit 1
1787 fi
1788 fi
1789 fi
1790 THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1791
1792 EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1793
1794 # We have a special set of source files in eesupp/src which are
1795 # generated from some template source files. We'll make them first so
1796 # they appear as regular source code
1797 if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1798 echo " Making source files in eesupp from templates"
1799 ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1800 RETVAL=$?
1801 if test "x${RETVAL}" = x0 ; then
1802 rm -f make_eesupp.errors
1803 else
1804 echo "Error: problem encountered while building source files in eesupp:"
1805 cat make_eesupp.errors 1>&2
1806 exit 1
1807 fi
1808 fi
1809
1810 #same for exch2
1811 if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1812 echo " Making source files in exch2 from templates"
1813 ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1814 RETVAL=$?
1815 if test "x${RETVAL}" = x0 ; then
1816 rm -f make_exch2.errors
1817 else
1818 echo "Error: problem encountered while building source files in exch2:"
1819 cat make_exch2.errors 1>&2
1820 exit 1
1821 fi
1822 fi
1823
1824 printf "\n=== Determining package settings ===\n"
1825 if test "x${PDEPEND}" = x ; then
1826 tmp=$ROOTDIR"/pkg/pkg_depend"
1827 if test -r $tmp ; then
1828 PDEPEND=$tmp
1829 else
1830 echo "Warning: No package dependency information was specified."
1831 echo " Please check that ROOTDIR/pkg/pkg_depend exists."
1832 fi
1833 else
1834 if test ! -r ${PDEPEND} ; then
1835 echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
1836 exit 1
1837 fi
1838 fi
1839 echo " getting package dependency info from $PDEPEND"
1840 # Strip the comments and then convert the dependency file into
1841 # two arrays: PNAME, DNAME
1842 cat $PDEPEND | sed -e 's/#.*$//g' \
1843 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1844 > ./.pd_tmp
1845 RETVAL=$?
1846 if test ! "x${RETVAL}" = x0 ; then
1847 echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1848 exit 1
1849 fi
1850 . ./.pd_tmp
1851 rm -f ./.pd_tmp
1852
1853 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
1854 # file should eventually be added so that, for convenience, one can
1855 # specify groups of packages using names like "ocean" and "atmosphere".
1856 echo " checking default package list: "
1857 if test "x${PDEFAULT}" = x ; then
1858 for i in "." $MODS ; do
1859 if test -r $i"/packages.conf" ; then
1860 PDEFAULT=$i"/packages.conf"
1861 break
1862 fi
1863 done
1864 fi
1865 if test "x${PDEFAULT}" = x ; then
1866 PDEFAULT="$ROOTDIR/pkg/pkg_default"
1867 fi
1868 if test "x${PDEFAULT}" = xNONE ; then
1869 echo " default packages file disabled"
1870 else
1871 if test ! -r $PDEFAULT ; then
1872 echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
1873 else
1874 echo " using PDEFAULT=\"$PDEFAULT\""
1875 # Strip the comments and add all the names
1876 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1877 RETVAL=$?
1878 if test "x${RETVAL}" != x0 ; then
1879 printf "Error: can't parse default package list "
1880 echo "-- please check PDEFAULT=\"$PDEFAULT\""
1881 exit 1
1882 fi
1883 for i in $def ; do
1884 PACKAGES="$PACKAGES $i"
1885 done
1886 echo " before group expansion packages are: $PACKAGES"
1887 RET=1
1888 while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1889 echo " after group expansion packages are: $PACKAGES"
1890 fi
1891 fi
1892
1893 echo " applying DISABLE settings"
1894 for i in $PACKAGES ; do
1895 echo $i >> ./.tmp_pack
1896 done
1897 for i in `grep "-" ./.tmp_pack` ; do
1898 j=`echo $i | sed 's/[-]//'`
1899 DISABLE="$DISABLE $j"
1900 done
1901 pack=
1902 for p in $PACKAGES ; do
1903 addit="t"
1904 for d in $DISABLE ; do
1905 if test "x$p" = "x$d" ; then
1906 addit="f"
1907 fi
1908 done
1909 if test "x$addit" = xt ; then
1910 pack="$pack $p"
1911 fi
1912 done
1913 PACKAGES="$pack"
1914 echo " applying ENABLE settings"
1915 echo "" > ./.tmp_pack
1916 PACKAGES="$PACKAGES $ENABLE"
1917 # Test if each explicitly referenced package exists
1918 for i in $PACKAGES ; do
1919 j=`echo $i | sed 's/[-+]//'`
1920 if test ! -d "$ROOTDIR/pkg/$j" ; then
1921 echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1922 exit 1
1923 fi
1924 echo $i >> ./.tmp_pack
1925 done
1926 PACKAGES=
1927 for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1928 PACKAGES="$PACKAGES $i"
1929 done
1930 rm -f ./.tmp_pack
1931 echo " packages are: $PACKAGES"
1932
1933 # Check availability of NetCDF and then either build the MNC template
1934 # files or delete mnc from the list of available packages.
1935 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1936 RETVAL=$?
1937 if test "x$RETVAL" = x0 ; then
1938 if test "x$HAVE_NETCDF" != xt ; then
1939 cat <<EOF
1940
1941 *********************************************************************
1942 WARNING: the "mnc" package was enabled but tests failed to compile
1943 NetCDF applications. Please check that:
1944
1945 1) NetCDF is correctly installed for this compiler and
1946 2) the LIBS variable (within the "optfile") specifies the correct
1947 NetCDF library to link against.
1948
1949 Due to this failure, the "mnc" package is now DISABLED.
1950 *********************************************************************
1951
1952 EOF
1953 PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1954 DISABLE="$DISABLE mnc"
1955 else
1956 ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1957 RETVAL=$?
1958 if test "x${RETVAL}" = x0 ; then
1959 rm -f make_mnc.errors
1960 else
1961 echo "Error: problem encountered while building source files in pkg/mnc:"
1962 cat make_mnc.errors 1>&2
1963 exit 1
1964 fi
1965 fi
1966 fi
1967
1968 echo " applying package dependency rules"
1969 ck=
1970 while test "x$ck" != xtt ; do
1971 i=0
1972 # rtot=${#PNAME[@]}
1973 rtot=$nname
1974 while test $i -lt $rtot ; do
1975
1976 # Is $pname in the current $PACKAGES list?
1977 # pname=${PNAME[$i]}
1978 tmp="pname=\"\$PNAME_$i\""
1979 eval $tmp
1980 pin="f"
1981 for p in $PACKAGES ; do
1982 if test "x$p" = "x$pname" ; then
1983 pin="t"
1984 fi
1985 done
1986
1987 # Is the DNAME entry a (+) or (-) rule ?
1988 tmp="dname=\"\$DNAME_$i\""
1989 eval $tmp
1990 plus="-"
1991 echo $dname | grep '^+' > /dev/null 2>&1
1992 RETVAL=$?
1993 if test "x$RETVAL" = x0 ; then
1994 plus="+"
1995 fi
1996
1997 # Is $dname in the current $PACKAGES list?
1998 dname=`echo $dname | sed -e 's/^[+-]//'`
1999 din="f"
2000 for p in $PACKAGES ; do
2001 if test "x$p" = "x$dname" ; then
2002 din="t"
2003 fi
2004 done
2005
2006 # Do we need to add $dname according to the dependency rules?
2007 if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2008 in_dis="f"
2009 for dis in $DISABLE ; do
2010 if test "x$dis" = "x$dname" ; then
2011 in_dis="t"
2012 fi
2013 done
2014 if test "x$in_dis" = xt ; then
2015 echo "Error: can't satisfy package dependencies:"
2016 echo " \"$dname\" is required by the dependency rules"
2017 echo " but is disallowed by the DISABLE settings"
2018 exit 1
2019 else
2020 PACKAGES="$PACKAGES $dname"
2021 ck=
2022 fi
2023 fi
2024
2025 # Do we need to get rid of $dname according to the dependency rules?
2026 if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
2027 echo "Error: can't satisfy package dependencies:"
2028 echo " \"$pname\" was requested but is disallowed by"
2029 echo " the dependency rules for \"$dname\""
2030 exit 1
2031 fi
2032 i=`echo "$i + 1" | bc -l`
2033 #i=$(( $i + 1 ))
2034 done
2035 ck=$ck"t"
2036 done
2037 echo " packages are: $PACKAGES"
2038 for i in $PACKAGES ; do
2039 adr="$ROOTDIR/pkg/$i"
2040 if test -d $adr ; then
2041 SOURCEDIRS="$SOURCEDIRS $adr"
2042 INCLUDEDIRS="$INCLUDEDIRS $adr"
2043 if test "x$i" = xautodiff ; then
2044 AUTODIFF_PKG_USED=t
2045 fi
2046 else
2047 echo "Error: the directory \"$adr\" for package $i doesn't exist"
2048 exit 1
2049 fi
2050 done
2051
2052 # Create a list of #define and #undef to enable/disable packages
2053 PACKAGES_DOT_H=PACKAGES_CONFIG.h
2054 # The following UGLY HACK sets multiple "#undef"s and it needs to go
2055 # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
2056 # file would eventually be split up so that all package-related #define
2057 # statements could be separated and handled only by genmake.
2058 names=`ls -1 "$ROOTDIR/pkg"`
2059 all_pack=
2060 DISABLED_PACKAGES=
2061 for n in $names ; do
2062 if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
2063 has_pack="f"
2064 for pack in $PACKAGES ; do
2065 if test "x$pack" = "x$n" ; then
2066 has_pack="t"
2067 break
2068 fi
2069 done
2070 if test "x$has_pack" = xf ; then
2071 undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2072 DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2073 fi
2074 fi
2075 done
2076 ENABLED_PACKAGES=
2077 for i in $PACKAGES ; do
2078 def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2079 ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2080 #eh3 DEFINES="$DEFINES -D$def"
2081
2082 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2083 case $i in
2084 aim_v23)
2085 ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
2086 echo "Warning: ALLOW_AIM is set to enable aim_v23."
2087 ;;
2088 esac
2089 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2090
2091 done
2092
2093 echo " Adding STANDARDDIRS"
2094 BUILDDIR=${BUILDDIR:-.}
2095 if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
2096 STANDARDDIRS="eesupp model"
2097 fi
2098 if test "x$STANDARDDIRS" != x ; then
2099 for d in $STANDARDDIRS ; do
2100 adr="$ROOTDIR/$d/src"
2101 if test ! -d $adr ; then
2102 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2103 echo " is correct and that you correctly specified the STANDARDDIRS option"
2104 exit 1
2105 else
2106 SOURCEDIRS="$SOURCEDIRS $adr"
2107 fi
2108 adr="$ROOTDIR/$d/inc"
2109 if test ! -d $adr ; then
2110 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2111 echo " is correct and that you correctly specified the STANDARDDIRS option"
2112 exit 1
2113 else
2114 INCLUDEDIRS="$INCLUDEDIRS $adr"
2115 fi
2116 done
2117 fi
2118
2119 echo " Searching for *OPTIONS.h files in order to warn about the presence"
2120 echo " of \"#define \"-type statements that are no longer allowed:"
2121 CPP_OPTIONS=
2122 CPP_EEOPTIONS=
2123 spaths=". $INCLUDEDIRS"
2124 names=`ls -1 "$ROOTDIR/pkg"`
2125 for i in $spaths ; do
2126 try="$i/CPP_OPTIONS.h"
2127 if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
2128 echo " found CPP_OPTIONS=\"$try\""
2129 CPP_OPTIONS="$try"
2130 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
2131 for n in $names ; do
2132 test_for_package_in_cpp_options $CPP_OPTIONS $n
2133 done
2134 fi
2135 try="$i/CPP_EEOPTIONS.h"
2136 if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
2137 echo " found CPP_EEOPTIONS=\"$try\""
2138 # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
2139 #**** not yet enabled ****
2140 # test_for_mpi_in_cpp_eeoptions $try
2141 #**** not yet enabled ****
2142 CPP_EEOPTIONS="$try"
2143 fi
2144 done
2145 if test "x$CPP_OPTIONS" = x ; then
2146 echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
2147 exit 1
2148 fi
2149
2150 # Here, we build the list of files to be "run through" the adjoint
2151 # compiler.
2152 if test -f ./ad_files ; then
2153 rm -f ./ad_files
2154 fi
2155 echo " Creating the list of files for the adjoint compiler."
2156 for i in $SOURCEDIRS ; do
2157 list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2158 for j in $list_files ; do
2159 cat $i/$j >> ad_files
2160 done
2161 done
2162 if test ! "x"$FS = "x.f" ; then
2163 cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2164 mv -f ad_files_f ad_files
2165 fi
2166
2167 echo
2168 echo "=== Creating the Makefile ==="
2169 echo " setting INCLUDES"
2170 for i in $INCLUDEDIRS ; do
2171 if test ! -d $i ; then
2172 echo "Warning: can't find INCLUDEDIRS=\"$i\""
2173 fi
2174 done
2175
2176 if test ! "x$DIVA" = x ; then
2177 echo " Creating the pseudo-MPI include directory"
2178 INCLUDES="-I./mpi_headers $INCLUDES"
2179 rm -rf ./mpi_headers
2180 mkdir -p ./mpi_headers
2181
2182 if test "x$MPIINCLUDEDIR" = x ; then
2183 if test "x$MPIHOME" = x ; then
2184 MPIHOME='/usr'
2185 fi
2186 MPIINCLUDEDIR='$MPIHOME/include'
2187 fi
2188
2189 if test -r $MPIINCLUDEDIR/mpif.h ; then
2190 for i in $MPI_HEADER_FILES; do
2191 cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2192 done
2193
2194 perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2195 else
2196 echo " We cannot create a copy of mpif.h!"
2197 exit -1
2198 fi
2199 fi
2200
2201 echo " Determining the list of source and include files"
2202 rm -rf .links.tmp
2203 mkdir .links.tmp
2204 touch .links.tmp/foo
2205 if test ! -r ".links.tmp/foo" ; then
2206 echo
2207 echo "ERROR : something is wrong with your directory permissions or"
2208 echo " your user file-creation mask (\"umask\") since creating a"
2209 echo " sub-dir, touch-ing a file within it, and then reading it is"
2210 echo " not working. Please try setting your umask to something"
2211 echo " sane such as:"
2212 echo
2213 echo " umask 0002"
2214 echo
2215 echo " and please verify that you have the proper permissions for"
2216 echo " creating sub-directories and then reading files created"
2217 echo " within them."
2218 echo
2219 exit 1
2220 fi
2221 rm -f .links.tmp/foo
2222 echo "# This section creates symbolic links" > srclinks.tmp
2223 echo "" >> srclinks.tmp
2224 printf 'SRCFILES = ' > srclist.inc
2225 printf 'CSRCFILES = ' > csrclist.inc
2226 printf 'F90SRCFILES = ' > f90srclist.inc
2227 printf 'HEADERFILES = ' > hlist.inc
2228 printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
2229 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2230 for d in $alldirs ; do
2231 deplist=
2232 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2233 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2234 for sf in $sfiles ; do
2235 if test ! -r ".links.tmp/$sf" ; then
2236 if test -f "$d/$sf" ; then
2237 ignore_f=f
2238 case $d/$sf in
2239 ./$PACKAGES_DOT_H)
2240 ignore_f=t
2241 ;;
2242 ./AD_CONFIG.h)
2243 ignore_f=t
2244 ;;
2245 ./FC_NAMEMANGLE.h)
2246 ignore_f=t
2247 ;;
2248 ./BUILD_INFO.h)
2249 ignore_f=t
2250 ;;
2251 ./EMBEDDED_FILES.h)
2252 ignore_f=t
2253 ;;
2254 *)
2255 # For the local directory *ONLY*,
2256 # ignore all soft-links
2257 if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2258 ignore_f=t
2259 else
2260 touch .links.tmp/$sf
2261 deplist="$deplist $sf"
2262 fi
2263 ;;
2264 esac
2265 if test "x$ignore_f" = xf ; then
2266 extn=`echo $sf | $AWK -F. '{print $NF}'`
2267 case $extn in
2268 F)
2269 echo " \\" >> srclist.inc
2270 printf " $sf" >> srclist.inc
2271 ;;
2272 F90)
2273 echo " \\" >> f90srclist.inc
2274 printf " $sf" >> f90srclist.inc
2275 ;;
2276 c)
2277 echo " \\" >> csrclist.inc
2278 printf " $sf" >> csrclist.inc
2279 ;;
2280 h)
2281 echo " \\" >> hlist.inc
2282 printf " $sf" >> hlist.inc
2283 ;;
2284 flow)
2285 echo " \\" >> ad_flow_files.inc
2286 printf " $sf" >> ad_flow_files.inc
2287 ;;
2288 esac
2289 fi
2290 fi
2291 fi
2292 done
2293 if test "x$deplist" != x ; then
2294 echo "" >> srclinks.tmp
2295 echo "# These files are linked from $d" >> srclinks.tmp
2296 echo "$deplist :" >> srclinks.tmp
2297 printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp
2298 fi
2299 done
2300 rm -rf .links.tmp
2301 echo "" >> srclist.inc
2302 echo "" >> csrclist.inc
2303 echo "" >> f90srclist.inc
2304 echo "" >> hlist.inc
2305 echo "" >> ad_flow_files.inc
2306
2307 if test -f $MAKEFILE ; then
2308 mv -f $MAKEFILE "$MAKEFILE.bak"
2309 fi
2310 echo " Writing makefile: $MAKEFILE"
2311 echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
2312 echo "# $MACHINE" >> $MAKEFILE
2313 echo "# This makefile was generated automatically on" >> $MAKEFILE
2314 echo "# $THISDATE" >> $MAKEFILE
2315 echo "# by the command:" >> $MAKEFILE
2316 echo "# $0 $G2ARGS" >> $MAKEFILE
2317 echo "# executed by:" >> $MAKEFILE
2318 echo "# ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2319
2320 EXE_AD=$EXECUTABLE"_ad"
2321 EXE_FTL=$EXECUTABLE"_ftl"
2322 EXE_SVD=$EXECUTABLE"_svd"
2323
2324 cat >>$MAKEFILE <<EOF
2325 #
2326 # OPTFILE="$OPTFILE"
2327 #
2328 # BUILDDIR : Directory where object files are written
2329 # SOURCEDIRS : Directories containing the source (.F) files
2330 # INCLUDEDIRS : Directories containing the header-source (.h) files
2331 # EXEDIR : Directory where executable that is generated is written
2332 # EXECUTABLE : Full path of executable binary
2333 #
2334 # CPP : C-preprocessor command
2335 # INCLUDES : Directories searched for header files
2336 # DEFINES : Macro definitions for CPP
2337 # MAKEDEPEND : Dependency generator
2338 # KPP : Special preprocessor command (specific to platform)
2339 # KFLAGS : Flags for KPP
2340 # FC : Fortran compiler command
2341 # FFLAGS : Configuration/debugging options for FC
2342 # FOPTIM : Optimization options for FC
2343 # LINK : Command for link editor program
2344 # LIBS : Library flags /or/ additional optimization/debugging flags
2345
2346 ROOTDIR = ${ROOTDIR}
2347 BUILDDIR = ${BUILDDIR}
2348 SOURCEDIRS = ${SOURCEDIRS}
2349 INCLUDEDIRS = ${INCLUDEDIRS}
2350 EXEDIR = ${EXEDIR}
2351 EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
2352 TOOLSDIR = ${TOOLSDIR}
2353
2354 #eh3 new defines for the adjoint work
2355 AUTODIFF = ${ROOTDIR}/pkg/autodiff
2356 EXE_AD = ${EXE_AD}
2357 EXE_FTL = ${EXE_FTL}
2358 EXE_SVD = ${EXE_SVD}
2359
2360 ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2361 DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2362
2363 # These files are created by Makefile
2364 SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
2365 EOF
2366
2367 if test "x$EMBED_SRC" = xt ; then
2368 echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2369 else
2370 echo "EMBEDDED_FILES = " >>$MAKEFILE
2371 fi
2372
2373 # Note: figure out some way to add Hyades JAM libraries here
2374 cat >>$MAKEFILE <<EOF
2375 # Unix ln (link)
2376 LN = ${LN}
2377 # C preprocessor
2378 CPP = cat \$< | ${S64} | ${CPP}
2379 # Dependency generator
2380 MAKEDEPEND = ${MAKEDEPEND}
2381 # Special preprocessor (KAP on DECs, FPP on Crays)
2382 KPP = ${KPP}
2383 # Fortran compiler
2384 FC = ${FC}
2385 # Fortran compiler
2386 F90C = ${F90C}
2387 # C compiler
2388 CC = ${CC}
2389 # Link editor
2390 LINK = ${LINK} ${LDADD}
2391
2392 # Defines for CPP
2393 DEFINES = ${DEFINES}
2394 # Includes for CPP
2395 INCLUDES = ${INCLUDES}
2396 # Flags for KPP
2397 KFLAGS1 = ${KFLAGS1}
2398 KFLAGS2 = ${KFLAGS2}
2399 # Optim./debug for FC
2400 FFLAGS = ${FFLAGS}
2401 FOPTIM = ${FOPTIM}
2402 # Optim./debug for FC
2403 F90FLAGS = ${F90FLAGS}
2404 F90OPTIM = ${F90OPTIM}
2405 # Flags for CC
2406 CFLAGS = ${CFLAGS}
2407 # Files that should not be optimized
2408 NOOPTFILES = ${NOOPTFILES}
2409 NOOPTFLAGS = ${NOOPTFLAGS}
2410 # Flags and libraries needed for linking
2411 LIBS = ${LIBS}
2412 # Name of the Mekfile
2413 MAKEFILE=${MAKEFILE}
2414
2415 EOF
2416
2417 cat srclist.inc >> $MAKEFILE
2418 cat csrclist.inc >> $MAKEFILE
2419 cat f90srclist.inc >> $MAKEFILE
2420 cat hlist.inc >> $MAKEFILE
2421 cat ad_flow_files.inc >> $MAKEFILE
2422 echo >> $MAKEFILE
2423 echo 'F77FILES = $(SRCFILES:.F=.'$FS')' >> $MAKEFILE
2424 echo 'F90FILES = $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2425 echo 'OBJFILES = $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2426 echo >> $MAKEFILE
2427 echo '.SUFFIXES:' >> $MAKEFILE
2428 echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2429 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2430 rm -f ad_flow_files.inc
2431
2432 cat >>$MAKEFILE <<EOF
2433
2434 all: \$(EXECUTABLE)
2435 \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2436 @echo Creating \$@ ...
2437 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2438 depend:
2439 @make links
2440 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2441 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2442 -rm -f makedepend.out
2443
2444 lib: libmitgcmuv.a
2445
2446 libmitgcmuv.a: \$(OBJFILES)
2447 ar rcv libmitgcmuv.a \$(OBJFILES)
2448
2449 links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2450
2451 small_f: \$(F77FILES) \$(F90FILES)
2452
2453 output.txt: \$(EXECUTABLE)
2454 @printf 'running ... '
2455 @\$(EXECUTABLE) > \$@
2456
2457 clean:
2458 -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2459 Clean:
2460 @make clean
2461 @make cleanlinks
2462 -rm -f \$(SPECIAL_FILES)
2463 -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2464 CLEAN:
2465 @make Clean
2466 -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2467 -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2468 -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2469 -rm -f \$(EXECUTABLE) *.txt STD* *diagnostics.log datetime
2470 -rm -rf mnc_test_*
2471
2472 #eh3 Makefile: makefile
2473 makefile:
2474 $THIS_SCRIPT $G2ARGS
2475 cleanlinks:
2476 -find . -type l -exec rm {} \;
2477
2478 # Special targets (SPECIAL_FILES) which are create by make
2479 ${PACKAGES_DOT_H}:
2480 @echo Creating \$@ ...
2481 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2482 AD_CONFIG.h:
2483 @echo Creating \$@ ...
2484 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2485 FC_NAMEMANGLE.h:
2486 @echo Creating \$@ ...
2487 echo "$FC_NAMEMANGLE" > \$@
2488
2489 BUILD_INFO.h:
2490 @echo Creating \$@ ...
2491 EOF
2492
2493 test ! "x$THISVER" = x && echo " -echo \"#define THISVER '$THISVER'\" > \$@" >> $MAKEFILE
2494 test ! "x$THISUSER" = x && echo " -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2495 test ! "x$THISDATE" = x && echo " -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2496 test ! "x$THISHOST" = x && echo " -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2497
2498 if test "x$EMBED_SRC" = xt ; then
2499 cat >>$MAKEFILE <<EOF
2500
2501 decode_files.o : EMBEDDED_FILES.h
2502
2503 ## \$(F77FILES)
2504 all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2505 @echo Creating \$@ ...
2506 -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2507 -rm -f all_fF.tar.gz
2508 -gzip all_fF.tar
2509
2510 EMBEDDED_FILES.h : all_fF.tar.gz
2511 @echo Creating \$@ ...
2512 -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2513
2514 EOF
2515 fi
2516
2517 cat >>$MAKEFILE <<EOF
2518
2519 # The normal chain of rules is ( .F - .$FS - .o )
2520
2521 ## This nullifies any default implicit rules concerning these two file types:
2522 ## %.o : %.F
2523
2524 .F.$FS:
2525 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2526 .$FS.o:
2527 \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2528 .F90.$FS90:
2529 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2530 .$FS90.o:
2531 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2532 .c.o:
2533 \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2534
2535 # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2536 .F.p:
2537 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2538 .p.$FS:
2539 \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2540
2541 #=========================================
2542 #=== Automatic Differentiation Rules ===
2543
2544 TAMC = ${TAMC}
2545 TAF = ${TAF}
2546
2547 TAF_EXTRA = ${TAF_EXTRA}
2548 TAMC_EXTRA = ${TAMC_EXTRA}
2549
2550 EOF
2551
2552 ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2553 ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2554 ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2555 for i in $ad_vars ; do
2556 name=$i
2557 t1="t2=\$"`echo $i`
2558 eval $t1
2559 printf "%-20s = " $name >> $MAKEFILE
2560 echo $t2 >> $MAKEFILE
2561 done
2562
2563 echo " Add the source list for AD code generation"
2564 echo >> $MAKEFILE
2565 printf "AD_FILES = " >> $MAKEFILE
2566 AD_FILES=`cat ad_files`
2567 for i in $AD_FILES ; do
2568 echo " \\" >> $MAKEFILE
2569 printf " $i" >> $MAKEFILE
2570 done
2571 echo >> $MAKEFILE
2572 rm -f ad_files
2573
2574 cat >>$MAKEFILE <<EOF
2575
2576 # ... AD ...
2577 adall: ad_taf
2578 adtaf: ad_taf_output.$FS
2579 adtamc: ad_tamc_output.$FS
2580
2581 ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2582 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2583 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2584 -rm -f ad_config.template
2585 @make \$(F77FILES)
2586 @make \$(AD_FLOW_FILES)
2587 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2588
2589 ad_taf_output.$FS: ad_input_code.$FS
2590 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2591 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2592
2593 adtafonly:
2594 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2595 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2596
2597 ad_taf: ad_taf_output.o \$(OBJFILES)
2598 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2599
2600 ad_tamc_output.$FS: ad_input_code.$FS
2601 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2602 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2603
2604 ad_tamc: ad_tamc_output.o \$(OBJFILES)
2605 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2606
2607 adonlyfwd:
2608 patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2609
2610 adtrick:
2611 patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2612
2613 # ... FTL ...
2614 ftlall: ftl_taf
2615 ftltaf: ftl_taf_output.$FS
2616 ftltamc: ftl_tamc_output.$FS
2617
2618 ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2619 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2620 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2621 -rm -f ftl_config.template
2622 @make \$(F77FILES)
2623 @make \$(AD_FLOW_FILES)
2624 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2625
2626 ftl_taf_output.$FS: ftl_input_code.$FS
2627 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2628 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2629
2630 ftltafonly:
2631 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2632 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2633
2634 ftl_taf: ftl_taf_output.o \$(OBJFILES)
2635 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2636
2637 ftl_tamc_output.$FS: ftl_input_code.$FS
2638 \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2639 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2640
2641 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2642 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2643
2644
2645 # ... SVD ...
2646 svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2647 @echo "--->>> Only ran TAF to generate SVD code! <<<---"
2648 @echo "--->>> Do make svdall afterwards to compile. <<<---"
2649 svdall: svd_touch svd_taf
2650
2651 svd_taf: \$(OBJFILES)
2652 \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2653
2654 @echo "--->>> Only COMPILE svd code! <<<---"
2655 @echo "--->>> Assumes you previously <<<---"
2656 @echo "--->>> did make svdtaf <<<---"
2657
2658 svd_touch:
2659 @echo "--->>> Only COMPILE svd code! <<<---"
2660 @echo "--->>> Assumes you previously <<<---"
2661 @echo "--->>> did make svdtaf <<<---"
2662 touch ad_taf_output.$FS ftl_taf_output.$FS
2663 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2664 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2665 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2666 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2667 -rm -f ftl_config.template
2668
2669 #=========================================
2670
2671 EOF
2672
2673 if test "x$EXEHOOK" != x ; then
2674 printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
2675 fi
2676
2677 echo " Making list of \"exceptions\" that need \".p\" files"
2678 for i in $KPPFILES ; do
2679 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
2680 RETVAL=$?
2681 if test "x$RETVAL" != x0 ; then
2682 echo "Error: unable to add file \"$i\" to the exceptions list"
2683 fi
2684 echo "$base.$FS: $base.p" >> $MAKEFILE
2685 done
2686
2687 echo " Making list of NOOPTFILES"
2688 for i in $NOOPTFILES ; do
2689 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
2690 RETVAL=$?
2691 if test "x$RETVAL" != x0 ; then
2692 echo "Error: unable to add file \"$i\" to the exceptions list"
2693 fi
2694 echo "$base.o: $base.$FS" >> $MAKEFILE
2695 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2696 done
2697
2698 echo " Add rules for links"
2699 cat srclinks.tmp >> $MAKEFILE
2700 rm -f srclinks.tmp
2701
2702 echo " Adding makedepend marker"
2703 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
2704
2705 printf "\n=== Done ===\n"
2706
2707 # Create special header files
2708 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2709 if test ! -f $PACKAGES_DOT_H ; then
2710 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2711 else
2712 cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2713 RETVAL=$?
2714 if test "x$RETVAL" = x0 ; then
2715 rm -f $PACKAGES_DOT_H".tmp"
2716 else
2717 mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2718 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2719 fi
2720 fi
2721 if test ! -f AD_CONFIG.h ; then
2722 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2723 fi
2724
2725
2726 # Write the "state" for future records
2727 if test "x$DUMPSTATE" != xf ; then
2728 printf "" > genmake_state
2729 for i in $gm_state ; do
2730 t1="t2=\$$i"
2731 eval $t1
2732 echo "$i='$t2'" >> genmake_state
2733 done
2734 fi

  ViewVC Help
Powered by ViewVC 1.1.22